<template>

</template>

<script>
import Form from "./../classes/Form"
import _ from "lodash"
    export default {
        data(){
            return{
                url :"default", 
                entities: [],
                searchHasData:false,
                paginator: {
                    current_page: 1,
                    per_page :10
                },
                params :
                {
                   per:10,
                   q:""
                },
                isLoading:false,
                paginationLoading: false,
                hasSearchAtBegining:false,
                performCrudAction:true,
                init:false,
                addLoading : false,
                searchTxt:"",
                entity : {},
                options:[],
                edit  : false,
                isSorted:false,
                sortedData:null,
                q:null,
                model : "",
                searched:false,
                _superMethods:{},
                //init
                initialization : true,
                
                form : new Form ({

                }),
                columns:[]
            }
        },
        created()
        {
            
            

        },
        mounted() {
           

            window.event.$on('openModal',() =>
           {
               this.$refs.createModal.open()
           
           });

           window.event.$on("closedModal",() =>
            {
               this.close()
            });

            window.event.$on("showRecordsEvent",(e) =>
            {
               this.par_page = parseInt(e)
               this.fetchData()
            });

           //Evenement quand on appuie sur un bouton de la pagination
           window.event.$on("paginationUpdatedOnNav",(e) =>
            {

               this.paginator = e
               this.entities= e.data
            });

           //Evenement quand on initialise la pagination
           window.event.$on("paginationInit",(e) =>
            {
               this.paginator = e
               //this.par_page = e.per_page
               this.entities= e.data
            });
            //Evenement quand la pagination charge
           window.event.$on("paginationIsLoading",(e) =>
            {
               this.performCrudAction = !e
            });
           window.event.$on("paginate",(e) =>
            {
                this.paginator = e
                this.fetch()

            });
            window.event.$on("searchPerEvent",(e) =>
            {
                this.paginator.per_page = e
                this.paginator.current_page = 1
                this.fetch();

            });




        },
        computed:
        {
           hasData()
           {
               if(this.entities==undefined)
               return true
               else
               return this.entities.length > 0 ? true : false
           },
           hasNoDataOnSearch()
           {
               return (this.searched && !this.hasData) ? true : false
     
           },
           
           noData()
           {
               return this.hasData == false && this.initialization == false
           },
           isLastPage()
           {
               return  this.$refs.pagination.paginator.last_page == this.$refs.pagination.paginator.current_page
           }
        },

        methods:
        {
            fetchData()
            {
                if(this.url)
                {
                    this.isLoading = true
                    //window.event.$emit("isLoading",true)
                    axios.get(this.url).then((response) => 
                    { 
                    
                    
                        window.event.$emit("paginationInit",response.data.entities)
                        if(response.data.options)
                        this.options = response.data.options
                        this.searched = false
                        this.initialization  = false
                        this.isLoading = false

                    },
                    (error) => { console.log("Promise Rejected: ", error.errors,this.form.errors) });
                }

            },
            fetch()
            {
            if(this.url)
                {
                   
                    this.isLoading = true
                    this.paginator['path']=this.url
                    window.event.$emit("isLoading",true)
                    //this.entities = []
                    axios.get(this.paginator.path+"?page="+this.paginator.current_page+"&per="+this.paginator.per_page, { params: {
                        sorted: this.sortedData,
                        q: this.q
                    }}).then((response) => 
                    { 
                          this.paginator = response.data.entities
                          window.event.$emit("paginationInit",response.data.entities)
                          if(this.init==false)
                          {
                           this.hasSearchAtBegining =response.data.entities.data.length>0
                           this.init = true
                          }
                          window.event.$emit("onPageLoadingDone")
                          this.isLoading = false
                          window.event.$emit("isLoading",false)
                                                  if(response.data.options)
                            this.options = response.data.options
                            this.searched = false
                            this.initialization  = false
                           // this.$root.scrollToTop();

                    },
                    (error) => { console.log("Promise Rejected: ", error.errors,this.form.errors) });
                }

            },
            onSubmit()
            {
                this.addLoading = true 
                if(this.edit == false)
                {
                    
                    this.form.post(this.url).then((value) => { 
                        //ajout de l'utilisateur
                        this.paginator = value.entities
                                            
                        this.entities= value.entities.data

                        this.entity.data = value.entity


                        window.event.$emit("paginationUpdatedOnCrud", this.paginator)
                        
                        //Ferme le modal
                        this.close()
                        //le flash
                        this. onStoreSuccess(value.entity)

                 },
                (error) => {
                    
                    this.addLoading = false
                    console.log("Promise Rejected: ", error.errors,this.form.errors) });
                }
                else
                {
                    console.log(this.url,"edd")
                    this.form.patch(this.url).then((value) => { 

                        console.log(value)
                        this.entities[this.entity.index] = value
                         //Ferme le modal
                        this.close()

                        this.onUpdateSuccess(value)
                       
                        

                    },
                    (error) => {
                         this.addLoading = false
                        console.log("Promise Rejected: ", error.errors,this.form.errors) });
                }

            },
            sortBy(column)
            {
                    if (typeof(column.sortable) !== 'undefined')
                    {
                        if(column.sortable)
                        {
                            this.sort(column)
                        }
                        else
                        {
                            return
                        }
                    }
                    else
                    {
                      this.sort(column)
                    }

            },
            sort(column)
            {
                    this.columns.forEach( e =>
                    {
                        if(column.key!==e.key)
                        {
                        e.sorted = false
                        e.asc = false
                        e.desc= false
                        }


                    })
                   if(!column.sorted)
                   {
                        column.sorted = true
                        column.asc = true
                        column.desc = false
                   }
                   else
                   {
                       column.asc = !column.asc 
                       column.desc = !column.desc
                   }
                   this.sortedData = column;
                   this.fetch()
            },
            assign(entity)
            {

                Object.keys(entity).forEach(element => {

                   
                    if(this.form.hasOwnProperty(element))
                    {
                       console.log(element)
                       this.form[element] = entity[element]
                    }
                });

            },
            filter(e)
            {
               console.log(this.paginator,e)
            },
            search()
            {
                if(this.searchTxt!="")
                {
                    axios.get("api/search",{ params: { keywords: this.searchTxt,model : this.model } }).then((value) => 
                    { 
                        this.paginator = value.data 
                        this.entities= value.data.data
                        window.event.$emit("paginationUpdatedOnSearch", this.paginator)
                        this.searched = true          
                    },
                    (error) =>
                    {

                    }
                    );
                }
                else
                {
                        
                }

            },
            onDeleteSuccess(entity=null)
            {
                  flash("<strong>L'élèment </strong> a été supprimé","success")
            },
             onStoreSuccess(entity=null)
            {
                flash("<strong>Le nouvel élèment </strong> a été ajouté","success")
            },
            onUpdateSuccess(entity=null)
            {
                flash("<strong>L'élèment a été supprimé</strong> a été modifié","success")
            },
        },
        watch:
        {
             edit(value)
             {
                  if(value == false)
                  {
                     this.url = "utilisateurs/store"
                     this.user = {}
                  }
                  
                 
             },
             searchTxt:_.debounce(function () 
             {
                if(this.searchTxt=="")
                {
                    this.params.q = null
                    this.init = true
                    this.searched =false
                }
                else
                {
                    this.params.q = this.searchTxt
                    this.init = true
                    this.searched =true
                }
                this.fetch()
            }, 500)
           
        }
    }
</script>
<style lang="scss" >
 .pagination .page-item
  {
      margin-left :5px;
      margin-right : 5px;
     
      a.page-link,a.page-link span,span.page-link {
            border-radius: 100%;
      }
     a.page-link span
     {
       padding: 0.1rem 0.2rem;
     }
      
  }
</style>

